//------------------------------------------------------------------
//
//
//
//------------------------------------------------------------------

extern int    EmaPeriod   = 7;
extern int    EmaPrice    = PRICE_CLOSE;
extern int    BarToTest   = 1;
extern int    MagicNumber = 1232344524285020;
extern double LotSize     = 0.1;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()   { return(0); }
int deinit() { return(0); }

//
//
//
//
//

#define _doNothing 0
#define _openBuy   1
#define _openSell  2

int start()
{
   double emaNow = iMA(NULL,0,EmaPeriod,0,MODE_EMA,EmaPrice,BarToTest);
   double emaPrv = iMA(NULL,0,EmaPeriod,0,MODE_EMA,EmaPrice,BarToTest+1);
   
      //
      //
      //
      //
      //
      
         int doWhat = _doNothing;
            if (emaNow<Close[BarToTest] && emaPrv>Close[BarToTest+1]) doWhat = _openBuy;
            if (emaNow>Close[BarToTest] && emaPrv<Close[BarToTest+1]) doWhat = _openSell;
            if (doWhat == _doNothing) return(0);
      
      //
      //
      //
      //
      //

         double openedBuys  = 0;
         double openedSells = 0;
         for (int i=OrdersTotal()-1; i>=0; i--)
         {
            if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
            if (OrderSymbol()      != Symbol())            continue;
            if (OrderMagicNumber() != MagicNumber)         continue;

            //
            //
            //
            //
            //
            
            RefreshRates(); 
               if (OrderType()==OP_SELL && doWhat==_openBuy)
               {
                  OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),0,CLR_NONE);
               }            
               else openedSells += 1;
               if (OrderType()==OP_BUY && doWhat==_openSell)
               {
                  OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),0,CLR_NONE);
               }            
               else openedBuys += 1;
         }
      
      //
      //
      //
      //
      //
      
      if (doWhat == _openBuy  && openedBuys ==0) OrderSend(Symbol(),OP_BUY ,LotSize,NormalizeDouble(Ask,Digits),0,0,0,"",MagicNumber,0,CLR_NONE);
      if (doWhat == _openSell && openedSells==0) OrderSend(Symbol(),OP_SELL,LotSize,NormalizeDouble(Bid,Digits),0,0,0,"",MagicNumber,0,CLR_NONE);
   return(0);
}